close all;
Q = 1.6e-19;
d = 1e-3;
f = logspace(5,10,1000);
V = 100;
m = 9.1e-31;
vo = sqrt(2*Q*V/m);
c1 = Q*exp(-1i*2*pi*f*d/vo);
c2 = CurrentDiracCst(Q,d,f,vo);

figure('Name','Dirc distribution','NumberTitle','off')
plot(f,abs(c1),'Color',[0.21,0.78,0.21],'LineWidth',2);
grid on
axis([0,1e10,0,1.7e-19])
legend('Current')
xlabel('Frequency in Hz')
ylabel('Gain in dB')
title('Body plot of current excitation function of frequencies')
set(gca,'xscale','log');

figure('Name','Rect distribution','NumberTitle','off')
plot(f,abs(c2),'Color',[1,0,0]         ,'LineWidth',2);
grid on
axis([0,1e10,0,1.7e-19])
legend('Current')
xlabel('Frequency in Hz')
ylabel('Gain in dB')
title('Body plot of current excitation function of frequencies')
set(gca,'xscale','log');