function [riseTime] = getRiseTime(signal,thresh,tinc)
% Takes in a waveform [signal] and finds the time taken to rise from
% CFthreshold [threshold] to 90% of maximum, by counting the indexes
% and multiplying by the time increment [tinc]

count=0;

[length,~] = size(signal);
top = max(signal)*.9;

for j = 1:length
    if( signal(j) > thresh && signal(j) < top)
        count=count+1;
    elseif( signal(j) > top )
        riseTime = count*tinc;
        return;
    end
end